SystemOrganization addCategory: #'Athens-Morphic'!

!LabelMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 8/31/2012 12:58'!
drawOnAthensCanvas: aCanvas
	"Draw based on enablement."
	
	|pc|
	pc := self owner
		ifNil: [self paneColor]
		ifNotNil: [self owner color isTransparent
					ifTrue: [self owner paneColor]
					ifFalse: [self owner color]].
	
	aCanvas pathTransform restoreAfter: [
		"aCanvas setPaint: Color blue;
			drawShape: (self bounds).
		"
		aCanvas pathTransform translateX: self left Y:
			self top + self fontToUse ascent.

		aCanvas 
			setFont: self fontToUse;
			setPaint: (self enabled ifTrue: [ self color ] ifFalse: [ pc muchDarker ] );
			drawString: self contents.
	]! !

!TextMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 3/8/2012 14:02'!
drawOnAthensCanvas: aCanvas

	"Draw the receiver on a canvas.
	Draw keyboard focus if appropriate."

	| fauxBounds |

	self setDefaultContentsIfNil.
	super drawOnAthensCanvas: aCanvas.  "Border and background if any"
	
	"nothing to draw?"
	(self startingIndex > text size)
		ifTrue: [ ^ self ].

	"Hack here:  The canvas expects bounds to carry the location of the text, but we also need to communicate clipping."
	fauxBounds := self bounds topLeft corner: self innerBounds bottomRight.
	
	self paragraph drawOnAthensCanvas: aCanvas bounds: fauxBounds.
	
	! !

!AthensBezier3Scene class methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 4/26/2013 17:53'!
openViewOn: aControlPointsArray
	
	^ AthensSceneView new
		scene: 	(self on: aControlPointsArray );
		openInWindow! !

!CompositeFillStyle methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/9/2012 19:10'!
asAthensPaintOn: aCanvas 
	^ AthensCompositePaint new fromFillStyles: fillStyles on: aCanvas! !

TextMorphForEditView subclass: #AthensTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensTextMorph commentStamp: '<historical>' prior: 0!
this class is subject of changes/removal. do not use it.!

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:42'!
contents: stringOrText wrappedTo: width
	"Accept new text contents.  Lay it out, wrapping to width.
	Then fit my height to the result."
	wrapFlag := true.
	super extent: width truncated@self height.
	self newContents: stringOrText! !

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:23'!
createParagraph
	| newParagraph |
	self setDefaultContentsIfNil.

	"...Code here to recreate the paragraph..."
	newParagraph  := AthensParagraph new.
	
	newParagraph
		compose: text
		style: textStyle copy
		in: self container.
		
		
	wrapFlag ifFalse:
		["Was given huge container at first... now adjust"
		newParagraph adjustRightX].
	
	newParagraph focused: (self currentHand keyboardFocus == self).
	
	paragraph := newParagraph.
	self fit.

	^ paragraph! !

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:18'!
paragraph
	^ paragraph ifNil: [ paragraph := self createParagraph ].
! !

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:02'!
selectionColor: aColor
	selectionColor := aColor.
	! !

!AthensCanvas methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 4/21/2011 14:27'!
fullDrawMorph: aMorph

"Hook method for potential other canvases. In the core, this method looks supefluous but PostscriptCanvases and other canvases can specialized it for Morph rendering. Therefore it should not be merged with fullDraw:."

	aMorph fullDrawOnAthensCanvas: self! !

!AthensCanvas methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/11/2012 15:25'!
morphicDrawString: string at: position font: aFont color: aColor

	self pathTransform restoreAfter: [
		self pathTransform translateX: position x Y: position y + aFont getPreciseAscent.
		self 
			setFont: aFont;
			setPaint: aColor;
			drawString: string.
	]
! !

!AthensCanvas methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/11/2012 15:23'!
morphicDrawString: string in: rect font: aFont color: aColor

	self pathTransform restoreAfter: [
		self pathTransform translateX: rect left Y: rect top.
		self clipBy: (0@0 corner: rect extent) during: [

			self 
				setFont: aFont.
				
			self pathTransform translateX: 0 Y: aFont getPreciseAscent.
			self
				setPaint: aColor;
				drawString: string.
			]
	]! !

!PluggableSliderMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/11/2012 14:41'!
drawOnAthensCanvas: aCanvas 

	super drawOn: aCanvas.
	aCanvas 
		morphicDrawString: self label
		in: self labelBounds
		font: self font
		color: self fontColor.
		
	
! !

AthensPaint subclass: #AthensCompositePaint
	instanceVariableNames: 'paints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensCompositePaint commentStamp: '<historical>' prior: 0!
i am used to convert CompositeFillStyle into paint, used in Morphic.!

!AthensCompositePaint methodsFor: 'drawing' stamp: 'IgorStasenko 10/9/2012 19:13'!
fillPath: athensPath on: anAthensCanvas 

	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "

	paints do: [:paint | 
				paint fillPath: athensPath on: anAthensCanvas ]
! !

!AthensCompositePaint methodsFor: 'drawing' stamp: 'IgorStasenko 10/9/2012 19:13'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	

	paints do: [:paint | 
				paint fillRectangle: aRect on: anAthensCanvas ]
! !

!AthensCompositePaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 10/9/2012 19:07'!
fromFillStyles: fillStyles on: aCanvas

	paints := fillStyles collect: [:each | each asAthensPaintOn: aCanvas ]! !

AthensPaint subclass: #AthensMorphicGradientPaint
	instanceVariableNames: 'gradient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensMorphicGradientPaint commentStamp: '<historical>' prior: 0!
i am used to convert gradient fill style(s) used in Morphic to appropriate paint(s) in Athens.!

!AthensMorphicGradientPaint methodsFor: 'rendering' stamp: 'IgorStasenko 4/12/2013 10:06'!
fillRectangle: aRect on: canvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	
	| fill |
	fill := gradient radial ifTrue: [
		canvas surface
			createRadialGradient: gradient colorRamp
			center:  (canvas pathTransform inverseTransform: gradient origin )
			radius: gradient direction y ]
	ifFalse: [
		canvas surface
			createLinearGradient: gradient colorRamp
			start: (canvas pathTransform inverseTransform: gradient origin)
			stop: (canvas pathTransform inverseTransform: gradient origin + gradient direction ) ].

	fill fillRectangle: aRect on: canvas.
! !

!AthensMorphicGradientPaint methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2012 16:14'!
gradient: aGradient
	gradient := aGradient! !

!StringMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/3/2012 17:27'!
drawOnAthensCanvas: canvas
	| pt bnd gap |
"	bnd := self bounds.
	gap := self layoutInset.
"	bnd := self bounds topLeft + self layoutInset.
	 
	font := self fontToUse.
	
	canvas pathTransform restoreAfter: [
		canvas pathTransform translateBy: bnd.
		canvas pathTransform translateX: 0 Y: font getPreciseAscent.
		
		canvas 
			setPaint: color;
			setFont: self fontToUse;
			drawString: contents.
	]! !

!LazyListMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/11/2012 15:29'!
athensDisplay: item atRow: row on: aCanvas 
	"Display the given item at the given row on the given
	canvas."
	
	| c drawBounds frame attrs useDefaultFont |
"
	drawBounds := self drawBoundsForRow: row.
	c := self colorForRow: row.
	aCanvas
		morphicDrawString: item asString
		at: drawBounds topLeft
		font: self font
		color: (self colorForRow: row)"! !

!LazyListMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/9/2012 19:04'!
athensDrawBackgroundForSearchedRow: row on: aCanvas 

	aCanvas setPaint: listSource  secondarySelectionColor.
	aCanvas drawShape: (self selectionFrameForRow: row)! !

!LazyListMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/9/2012 19:03'!
athensDrawBackgroundForSelectedRow: row on: aCanvas 

	aCanvas setPaint: listSource selectionColorToUse.
	aCanvas drawShape: (self selectionFrameForRow: row)! !

!LazyListMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/4/2011 16:50'!
athensDrawSelectionOn: anAthensCanvas 
	
self value! !

!LazyListMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/11/2012 15:12'!
drawOnAthensCanvas: aCanvas

	"self drawSelectionOn: aCanvas."
	1 to: listItems size do: [:row |
		(listSource itemSelectedAmongMultiple: row)
			ifTrue: [ self athensDrawBackgroundForSelectedRow: row on: aCanvas]
			ifFalse: [
				(listSource searchedElement = row)
					ifTrue: [ self athensDrawBackgroundForSearchedRow: row on: aCanvas]
					ifFalse: [
						(listSource backgroundColorFor: row)
							ifNotNil: [:col |
								self athensDrawBackgroundForRow: row on: aCanvas color: col ]]].
					
			selectedRow = row ifTrue: [ self athensDrawSelectionOn: aCanvas ].
			(listSource separatorAfterARow: row) ifTrue: [ self athensDrawSeparatorAfter: row on: aCanvas ].
			self
				athensDisplay: (self item: row)
				atRow: row
				on: aCanvas].
		
	"listSource potentialDropRow > 0
		ifTrue: [self athensHighlightPotentialDropRow: listSource potentialDropRow on: aCanvas]"! !

!PasteUpMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 4/21/2011 14:33'!
drawOnAthensCanvas: aCanvas 
	"Draw in order:
	- background color
	- background sketch, if any
	- Update and draw the turtleTrails form. See the comment in updateTrailsForm.

	Later (in drawSubmorphsOn:) I will skip drawing the background sketch."

	"draw background fill"
	super drawOnAthensCanvas: aCanvas.

	backgroundMorph ifNotNil: [
		aCanvas clipBy: self clippingBounds
			during: [ aCanvas fullDrawMorph: backgroundMorph ]
	]				
! !

!TransformMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/7/2012 23:18'!
clipDuring: aBlock canvas: aCanvas 

	self clipSubmorphs 
		ifTrue: [ 
			aCanvas
				clipBy: self clippingBounds 
				during: aBlock ] 
		ifFalse: [ ^ aBlock value ]
! !

!TransformMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/7/2012 23:22'!
drawClippedOn: aCanvas during: aBlock

	^ self clipSubmorphs 
		ifTrue: [ 
			 aCanvas
				clipBy: self clippingBounds 
				during: aBlock ] 
		ifFalse: [ aBlock value ]
! !

!TransformMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/7/2012 23:21'!
fullDrawOnAthensCanvas: anAthensCanvas 
	"Draw the full Morphic structure on the given Canvas"

	self visible ifFalse: [^ self].
	(anAthensCanvas isVisible: self fullBounds) ifFalse: [^self].
	(self hasProperty: #errorOnDraw) ifTrue: [^self "drawErrorOn: aCanvas" ].

	(anAthensCanvas isVisible: self bounds) ifTrue: [ anAthensCanvas draw: self ].
	
	submorphs isEmpty ifTrue: [^self].

	self clipDuring: [
		anAthensCanvas pathTransform restoreAfter: [
			anAthensCanvas pathTransform translateBy: self transform offset negated. 
			submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ] ]
		] canvas: anAthensCanvas.


! !

!ImageMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 7/3/2013 15:51'!
drawOnAthensCanvas: aCanvas
	
	| cached |
	
	cached := aCanvas cacheAt: image ifAbsentPut: [
		image asAthensPaintOn: aCanvas.
		].
	
	aCanvas setPaint: cached.
		
		aCanvas paintTransform restoreAfter: [
			aCanvas paintTransform translateBy: self innerBounds origin "negated".
		
			aCanvas drawShape: self innerBounds.
		].
	
! !

PluggableTextMorph subclass: #AthensPluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensPluggableTextMorph commentStamp: '<historical>' prior: 0!
this class is subject of changes/removal. do not use it.!

!AthensPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:01'!
textMorphClass
	^ AthensTextMorph! !

Morph subclass: #AthensSceneView
	instanceVariableNames: 'surface scene session transform state keepRefreshing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensSceneView commentStamp: '<historical>' prior: 0!
i am simple morph for representing some scene.

The scene is any object which implements #renderOn: method,
or a block with single argument.
(an argument passed is an Athens canvas).

I implement a simple view panning and zooming with mouse drag and mouse-wheel (correspondigly).

Example1: open scene view, by passing a simple rendering block.

| view |
view  := AthensSceneView new.

view scene: [:canvas |
	canvas surface clear:  Color black.
	canvas setPaint: Color red.
	canvas drawShape: (0@0 corner:120@100)
].
view openInWindow.

Example2: open scene view on imported SVG file (note you need 'Athens-SVG' package loaded):

| view |
view  := AthensSceneView new.
view scene: (AthensSVGConverter fromFile: 'lion.svg').

view openInWindow.
!

AthensSceneView subclass: #AthensInteractiveScene
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensInteractiveScene commentStamp: '<historical>' prior: 0!
i am like my superclass, can display any scene (object which understands #renderOn:  message)
and support free-form pan and zoom.

but in addition, i expecting that scene object understands following:

scene handleEvent: event in: sceneView at: position
 
This method should answer true if scene object wants to handle event by itself , preventing default handling of view (pan & zoom).
The point is coordinates of event in scene coordinate space (not screen coordinate space). The event is MorphicEvent (currently limited only to mouse move&button events).

Note that if scene view enters zooming or panning state, no events will be passed to scene object as long as state is active. 


!

!AthensInteractiveScene methodsFor: 'event handling' stamp: 'IgorStasenko 6/1/2013 05:13'!
eventHandledByScene: evt

	^  true == (scene handleEvent: evt in: self at: (self eventPositionInScene:evt))
	! !

!AthensInteractiveScene methodsFor: 'event handling' stamp: 'IgorStasenko 6/1/2013 05:08'!
eventPositionInScene: evt
	| pt | 
	
	pt := evt position - self topLeft.
	
	^ transform transform: pt! !

!AthensInteractiveScene methodsFor: 'event handling' stamp: 'IgorStasenko 6/1/2013 05:17'!
mouseDown: evt

	((self inState: #panning) or: [ self inState:#zooming ]) 
		ifFalse: [
			(self eventHandledByScene: evt) ifTrue: [ ^ self ]. 	
		].

	^ super mouseDown: evt! !

!AthensInteractiveScene methodsFor: 'event handling' stamp: 'IgorStasenko 6/1/2013 05:12'!
mouseMove: evt

	((self inState: #panning) or: [ self inState:#zooming ]) 
		ifFalse: [
			(self eventHandledByScene: evt) ifTrue: [ ^ self ]. 	
		].
	^ super mouseMove: evt! !

!AthensInteractiveScene methodsFor: 'event handling' stamp: 'IgorStasenko 6/1/2013 05:16'!
mouseUp: evt

	((self inState: #panning) or: [ self inState:#zooming ]) 
		ifFalse: [
			(self eventHandledByScene: evt) ifTrue: [ ^ self ]. 	
		].
		
	^ super mouseUp:evt ! !

!AthensSceneView methodsFor: 'colors' stamp: 'IgorStasenko 4/21/2013 15:01'!
backgroundColor
	^ Color gray! !

!AthensSceneView methodsFor: 'session management' stamp: 'IgorStasenko 4/21/2013 04:37'!
checkSession

	session == Smalltalk session ifFalse: [ 
		self initializeForNewSession
		 ]! !

!AthensSceneView methodsFor: 'session management' stamp: 'IgorStasenko 4/21/2013 04:40'!
createSurface
	| extent |
	extent := self extent asIntegerPoint.
	(scene respondsTo: #createSurface:) ifTrue: [
		surface := scene createSurface: extent.
	  ] ifFalse: [ surface := AthensCairoSurface extent: extent].
! !

!AthensSceneView methodsFor: 'drawing' stamp: 'IgorStasenko 8/12/2013 15:18'!
drawOn: canvas
	| px py |
	canvas fillRectangle: bounds color: self backgroundColor.
	self renderScene.
	canvas translucentImage: surface asForm at: bounds origin.
	self showDebugInfo
		ifTrue: [ 
			px := transform x printShowingDecimalPlaces: 3.
			py := transform y printShowingDecimalPlaces: 3.
			canvas
				drawString: 'zoom: ' , (transform sx printShowingDecimalPlaces: 3) , ' pan: ' , px , ' @ ' , py
				at: bounds origin
				font: nil
				color: Color white ]! !

!AthensSceneView methodsFor: 'event handling' stamp: 'IgorStasenko 4/21/2013 05:02'!
handlesMouseDown: evt
	^ true! !

!AthensSceneView methodsFor: 'event handling' stamp: 'IgorStasenko 4/21/2013 05:13'!
handlesMouseOver: evt
	^ true! !

!AthensSceneView methodsFor: 'event handling' stamp: 'IgorStasenko 4/21/2013 06:01'!
handlesMouseWheel: event
	^ true! !

!AthensSceneView methodsFor: 'state tracking' stamp: 'IgorStasenko 4/21/2013 05:37'!
inState: stateName


	^ (state at: stateName ifAbsent: nil) notNil! !

!AthensSceneView methodsFor: 'state tracking' stamp: 'IgorStasenko 4/21/2013 05:45'!
inState: stateName do: aBlock


	^ (state at: stateName ifAbsent: nil) ifNotNil: aBlock ! !

!AthensSceneView methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/8/2013 18:37'!
initialize

	super initialize.
	keepRefreshing := false.
	transform := AthensAffineTransform new.
	
	self hResizing: #spaceFill.
	self vResizing: #spaceFill.
	color := Color transparent.
	state := Dictionary new.
	self extent: self minimumExtent.
	
! !

!AthensSceneView methodsFor: 'session management' stamp: 'IgorStasenko 4/21/2013 04:40'!
initializeForNewSession

	self createSurface.
	session := Smalltalk session.
! !

!AthensSceneView methodsFor: 'accessing' stamp: 'IgorStasenko 6/3/2013 14:27'!
keepRefreshing: aBoolean
	keepRefreshing := aBoolean.
	
	keepRefreshing ifTrue: [  self startStepping ].! !

!AthensSceneView methodsFor: 'layout' stamp: 'IgorStasenko 4/21/2013 05:39'!
layoutChanged 
	"react on morph resize"
	super layoutChanged.
	surface ifNotNil: [  
		self extent asIntegerPoint ~= surface extent ifTrue: [ 
			self createSurface ]
	].
	! !

!AthensSceneView methodsFor: 'initialize-release' stamp: 'IgorStasenko 4/21/2013 06:50'!
minimumExtent
	^ 300@300! !

!AthensSceneView methodsFor: 'event handling' stamp: 'IgorStasenko 4/21/2013 06:12'!
mouseDown: evt

	| pos |
	
	pos := evt cursorPoint.
	
	"left button"
	evt redButtonPressed ifTrue: [ 
		self setState: #panning value: { transform x@transform y. pos }
		 ].
	
! !

!AthensSceneView methodsFor: 'event handling' stamp: 'IgorStasenko 4/21/2013 05:41'!
mouseEnter: evt

	self setState: #mouseIn! !

!AthensSceneView methodsFor: 'event handling' stamp: 'IgorStasenko 4/21/2013 05:44'!
mouseLeave: evt
	self 
		resetState: #mouseIn;
		resetState: #panning.! !

!AthensSceneView methodsFor: 'event handling' stamp: 'IgorStasenko 4/21/2013 06:15'!
mouseMove: evt

	self inState: #panning do: [ :startPanAndPos |
		| delta |
		delta := startPanAndPos first + ( evt cursorPoint - startPanAndPos second ).
		
		transform 
			x: delta x;
			y: delta y.
		self changed.
	] ! !

!AthensSceneView methodsFor: 'event handling' stamp: 'IgorStasenko 4/21/2013 05:44'!
mouseUp: evt

	"self halt."
	
	self resetState: #panning! !

!AthensSceneView methodsFor: 'event handling' stamp: 'IgorStasenko 4/22/2013 15:00'!
mouseWheel: event


	"Handle a mouseWheel event."
	
	| center zoom  |
	
	center := transform inverseTransform: (event cursorPoint - bounds origin).

	zoom := 1.
	
	event direction = #up ifTrue: [ zoom := 1.25 ].
	event direction = #down ifTrue: [ zoom := 1/1.25 ].
	
	
	(self inState: #zooming) ifTrue: [   
		self updateZoom: zoom cursor: event cursorPoint.
	] ifFalse: [
		self startZooming: zoom center: center.
	]  ! !

!AthensSceneView methodsFor: 'drawing' stamp: 'IgorStasenko 8/12/2013 15:18'!
renderScene

	self checkSession.

	scene ifNotNil: [ 
		surface drawDuring: [ :acanvas | 
			surface clear.
			acanvas pathTransform loadAffineTransform: transform.
			scene isBlock
				ifTrue: [ scene cull: acanvas cull: self ]
				ifFalse: [ scene renderOn: acanvas ] ] ]! !

!AthensSceneView methodsFor: 'state tracking' stamp: 'IgorStasenko 4/21/2013 05:39'!
resetState: stateName

	state at: stateName put: nil.

	"receiver's state changed"
	
	self changed.! !

!AthensSceneView methodsFor: 'accessing' stamp: 'IgorStasenko 4/21/2013 05:51'!
scene
	^ scene! !

!AthensSceneView methodsFor: 'accessing' stamp: 'IgorStasenko 4/25/2013 01:19'!
scene: aScene
	
	scene := aScene.
	
	self changed.! !

!AthensSceneView methodsFor: 'state tracking' stamp: 'IgorStasenko 4/21/2013 05:39'!
setState: stateName

	state at: stateName put: true.

	"receiver's state changed"
	
	self changed.! !

!AthensSceneView methodsFor: 'state tracking' stamp: 'IgorStasenko 4/21/2013 05:39'!
setState: stateName value: aValue

	state at: stateName put: aValue.

	"receiver's state changed"
	
	self changed.! !

!AthensSceneView methodsFor: 'drawing' stamp: 'IgorStasenko 4/26/2013 14:46'!
showDebugInfo
	^ true ! !

!AthensSceneView methodsFor: 'zoom animation' stamp: 'IgorStasenko 4/22/2013 14:41'!
startZooming: zoom center: center
	| start end |

		
	start := Time millisecondClockValue.
	end := start + 250.

	self setState: #zooming value: {  center. transform copy. zoom. start. end}.

	self startStepping! !

!AthensSceneView methodsFor: 'zoom animation' stamp: 'IgorStasenko 6/1/2013 14:09'!
step

	self inState: #zooming do: [ :zoomState |
		| now start end center targetZoom factor |
		now := Time millisecondClockValue.
		start := zoomState at: 4.
		end := zoomState at: 5.
		
		(now between: start and:end) ifFalse: [ now := end.
			self resetState: #zooming.
			self stopStepping ].
		
		transform := (zoomState at: 2) copy.
		center := zoomState at: 1.
		
		factor :=  (now-start)/(end - start ).
		targetZoom := zoomState at: 3.
		targetZoom := 1* (1-factor) + (targetZoom * factor).
		
		transform
			translateBy: center;
			scaleBy:targetZoom;
			translateBy: center negated.
		
	].
	self changed.
! !

!AthensSceneView methodsFor: 'zoom animation' stamp: 'IgorStasenko 4/22/2013 14:22'!
stepTime
	^ 0! !

!AthensSceneView methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/3/2013 14:27'!
stopStepping
	keepRefreshing ifFalse: [
			^ super stopStepping ]! !

!AthensSceneView methodsFor: 'zoom animation' stamp: 'IgorStasenko 4/22/2013 15:01'!
updateZoom: zoom cursor: cursorPoint

	| zoomState targetZoom start end now fraction newCenter |
	zoomState := state at:#zooming.
		
	"change the target zoom and increase time a bit"
	targetZoom := zoomState at: 3.
	
	start := zoomState at: 4.
	end := zoomState at: 5.
		
	now := Time millisecondClockValue.
	
	(now > end) ifTrue: [  now := end ].
	
	 "interpolate linearly the target zoom factor over time start ... end"
	fraction := (now - start) / (end - start).
	
	"zoom goes from 1..target zoom"
	targetZoom := 1*(1-fraction) + (targetZoom * fraction).

	self step. "to update transform"
	zoomState at: 3 put: targetZoom * zoom.
	newCenter :=   transform inverseTransform: (cursorPoint - bounds origin).
	zoomState at: 1 put: newCenter.
	zoomState at: 2 put: transform copy.
	zoomState at: 4 put: now.
	zoomState at: 5 put: now + 250 .
! !

!Morph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/11/2012 16:51'!
drawOnAthensCanvas: anAthensCanvas 
	| border |
	border := self borderStyle. 
	anAthensCanvas setPaint: self fillStyle.
	anAthensCanvas drawShape: self bounds.
	
	"Fill the given rectangle."
	anAthensCanvas drawShape: (self bounds insetBy: border width).

	(anAthensCanvas setStrokePaint: border color) width: border width.
	anAthensCanvas drawShape: (self bounds insetBy: (border width /2 asFloat)).
	

	"aBorderStyle frameRectangle: aRectangle on: self "
	
	! !

!Morph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 9/2/2012 21:44'!
fullDrawOnAthensCanvas: anAthensCanvas 
	"Draw the full Morphic structure on the given Canvas"

	self visible ifFalse: [^ self].
	(anAthensCanvas isVisible: self fullBounds) ifFalse: [^self].
	(self hasProperty: #errorOnDraw) ifTrue: [^self "drawErrorOn: aCanvas" ].

	(anAthensCanvas isVisible: self bounds) ifTrue: [ anAthensCanvas draw: self ].
	
	submorphs isEmpty ifTrue: [^self].

	self clipSubmorphs ifTrue: [ | clip |
		clip := self clippingBounds.
		anAthensCanvas 
			clipBy: clip
			during: [
				submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ] 
			]
	] 
	ifFalse: [
		submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ]
	]
! !

!Morph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 11/7/2012 19:16'!
testAthensRender

| surf |
	surf := AthensCairoSurface extent: Display extent.

	surf drawDuring: [:can |
"		can pathTransform scaleBy: 0.5; rotateByDegrees: 30."
		self fullDrawOnAthensCanvas: can ].

	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!Paragraph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/8/2012 04:21'!
drawOnAthensCanvas: aCanvas bounds: aRectangle 
	"do nothing"! !

!IndentingListItemMorph methodsFor: '*Athens-Morphic' stamp: 'IgorStasenko 10/11/2012 14:56'!
drawOnAthensCanvas: aCanvas 
	| tRect sRect columnScanner colorToUse columnLeft |
	tRect := self toggleRectangle.
	sRect := bounds withLeft: tRect right + 4.
"	self 
		athensDrawToggleOn: aCanvas
		in: tRect.
"		
	colorToUse := complexContents preferredColor ifNil: [ color ].
	icon isNil ifFalse: 
		[ "aCanvas 
			translucentImage: icon
			at: sRect left @ (self top + ((self height - icon height) // 2))."
		sRect := sRect left: sRect left + icon width + 2 ].
	(container columns isNil or: [ (contents asString indexOf: Character tab) = 0 ]) 
		ifTrue: 
			[ sRect := sRect top: (sRect top + sRect bottom - self fontToUse height) // 2.
			"contents
				treeRenderOn: aCanvas 
				bounds: sRect 
				color: colorToUse 
				font: self 
				fontToUse 
				from: self" ]
		ifFalse: 
			[ columnLeft := sRect left.
			columnScanner := contents asString readStream.
			container columns do: 
				[ :width | | columnData columnRect | 
				columnRect := columnLeft @ sRect top extent: width @ sRect height.
				columnData := columnScanner upTo: Character tab.
				columnData isEmpty ifFalse: 
					[ aCanvas 
						morphicDrawString: columnData
						in: columnRect
						font: self fontToUse
						color: colorToUse ].
				columnLeft := columnRect right + 5 ] ]! !

Object subclass: #AthensParagraph
	instanceVariableNames: 'text textStyle containerRect lines positionWhenComposed selectionStart selectionStop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Morphic'!

!AthensParagraph commentStamp: '<historical>' prior: 0!
this class is subject of changes/removal. do not use it.!

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 01:31'!
caretRect ^ (0@0 corner: 0@0)  ! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 16:08'!
characterBlockForIndex: index 

		^ self defaultCharacterBlock! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:22'!
compose: aText style: aTextStyle from: startingIndex in: aRectangle 
	text := aText.
	textStyle := aTextStyle
	
	self shouldBeImplemented.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:50'!
compose: aText style: aTextStyle in: rect 

	text := aText.
	textStyle := aTextStyle.
	containerRect := rect.
	lines := (AthensTextComposer scan: aText for: AthensTextScanner new) lines.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:04'!
defaultCharacterBlock
	^ (CharacterBlock new stringIndex: 1 text: text
			topLeft: 0@0 extent: 0 @ 0)
		textLine: lines first! !

!AthensParagraph methodsFor: 'drawing' stamp: 'IgorStasenko 10/7/2012 23:32'!
drawOnAthensCanvas: canvas bounds: aRectangle 

	| renderer |
	"self halt."
"	canvas
		clipBy: aRectangle 
		during: [  
"			renderer := AthensTextRenderer new.
			renderer render: text lines: lines on: canvas.
"		].
"! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:48'!
extent
	^ containerRect width @ lines last bottom! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:07'!
extraSelectionChanged
"
	refreshExtraSelection := true
"

	self flag: #foo! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:06'!
findReplaceSelectionRegex: aRegex
"	findReplaceSelectionRegex := aRegex. "
	self flag: #foo
! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 01:28'!
focused ^ false! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:45'!
focused: bool

	"why we should care?"
	
	"self flag: #ooo"! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:00'!
positionWhenComposed: pos
	positionWhenComposed := pos! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:06'!
secondarySelection: aSubString
"	secondarySelection := aSubString."
	self flag: #foo.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:02'!
selectionColor: anUndefinedObject 
	self shouldBeImplemented.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:08'!
selectionRects
	^ #()! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:09'!
selectionStart: startBlock selectionStop: stopBlock
	selectionStart := startBlock.
	selectionStop := stopBlock.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 01:28'!
showCared ! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 01:29'!
showCaret  ! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/31/2012 01:29'!
showCaret: abool  ! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:05'!
text
	^ text! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:20'!
textOwner: anUndefinedObject 
	self shouldBeImplemented.! !
